diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/lr-wpan/test/lr-wpan-ack-test.cc ns-3.33/src/lr-wpan/test/lr-wpan-ack-test.cc
--- ns-3.32/src/lr-wpan/test/lr-wpan-ack-test.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/lr-wpan/test/lr-wpan-ack-test.cc	2021-01-09 10:19:22.000000000 -0800
@@ -17,6 +17,8 @@
  *
  * Author:
  *  Sascha Alexander Jopen <jopen@cs.uni-bonn.de>
+ * Modifications:
+ *  Tommaso Pecorella <tommaso.pecorella@unifi.it>
  */
 
 #include <ns3/log.h>
@@ -31,6 +33,9 @@
 #include "ns3/rng-seed-manager.h"
 
 #include <iostream>
+#include <string>
+#include <fstream>
+#include <streambuf>
 
 using namespace ns3;
 
@@ -50,129 +55,117 @@
 class LrWpanAckTestCase : public TestCase
 {
 public:
-  LrWpanAckTestCase ();
+
+  typedef enum
+  {
+    EXTENDED_ADDRESS_UNICAST,
+    SHORT_ADDRESS_UNICAST,
+    SHORT_ADDRESS_MULTICAST,
+    SHORT_ADDRESS_BROADCAST,
+  } TestMode_e;
+
+  /**
+   * Create test case
+   *
+   * \param prefix Unique file names prefix
+   * \param mode   Test mode
+   */
+  LrWpanAckTestCase (const char * const prefix, TestMode_e mode);
 
   /**
-   * \brief Function called when DataIndication is hit.
+   * \brief Function called when DataIndication is hit on dev0.
    * \param testCase The TestCase.
-   * \param dev The LrWpanNetDevice.
    * \param params The MCPS params.
    * \param p the packet.
    */
-  static void DataIndication (LrWpanAckTestCase *testCase, Ptr<LrWpanNetDevice> dev, McpsDataIndicationParams params, Ptr<Packet> p);
+  void DataIndicationDev0 (McpsDataIndicationParams params, Ptr<Packet> p);
   /**
-   * \brief Function called when DataConfirm is hit.
+   * \brief Function called when DataIndication is hit on dev1.
    * \param testCase The TestCase.
-   * \param dev The LrWpanNetDevice.
    * \param params The MCPS params.
+   * \param p the packet.
    */
-  static void DataConfirm (LrWpanAckTestCase *testCase, Ptr<LrWpanNetDevice> dev, McpsDataConfirmParams params);
+  void DataIndicationDev1 (McpsDataIndicationParams params, Ptr<Packet> p);
   /**
-   * \brief Function called when DataIndication is hit in extended addressing test.
+   * \brief Function called when DataConfirm is hit on dev0.
    * \param testCase The TestCase.
-   * \param dev The LrWpanNetDevice.
    * \param params The MCPS params.
-   * \param p the packet.
    */
-  static void ExtendedAddressingDataIndication (LrWpanAckTestCase *testCase, Ptr<LrWpanNetDevice> dev, McpsDataIndicationParams params, Ptr<Packet> p);
+  void DataConfirmDev0 (McpsDataConfirmParams params);
   /**
-   * \brief Function called when DataConfirm is hit in extended addressing test.
+   * \brief Function called when DataConfirm is hit on dev1.
    * \param testCase The TestCase.
-   * \param dev The LrWpanNetDevice.
    * \param params The MCPS params.
    */
-  static void ExtendedAddressingDataConfirm (LrWpanAckTestCase *testCase, Ptr<LrWpanNetDevice> dev, McpsDataConfirmParams params);
+  void DataConfirmDev1 (McpsDataConfirmParams params);
 
 private:
   virtual void DoRun (void);
 
+  std::string m_prefix; //!< Filename prefix
   Time m_requestTime; //!< Request time.
-  Time m_requestAckTime; //!< Request ack time.
+  Time m_requestSentTime; //!< Request successfully sent time.
   Time m_replyTime; //!< Reply time.
-  Time m_replyAckTime; //!< Reply ack time.
+  Time m_replySentTime; //!< Reply successfully sent time.
   Time m_replyArrivalTime; //!< Reply arrival time.
+  TestMode_e m_mode; //!< Test mode.
+  Ptr<LrWpanNetDevice> m_dev0;  //!< 1st LrWpanNetDevice.
+  Ptr<LrWpanNetDevice> m_dev1;  //!< 2nd LrWpanNetDevice.
 };
 
-LrWpanAckTestCase::LrWpanAckTestCase ()
+LrWpanAckTestCase::LrWpanAckTestCase (const char * const prefix, TestMode_e mode)
   : TestCase ("Test the 802.15.4 ACK handling")
 {
+  m_prefix = prefix;
   m_requestTime = Seconds (0);
-  m_requestAckTime = Seconds (0);
+  m_requestSentTime = Seconds (0);
   m_replyTime = Seconds (0);
-  m_replyAckTime = Seconds (0);
+  m_replySentTime = Seconds (0);
   m_replyArrivalTime = Seconds (0);
+  m_mode = mode;
 }
 
 void
-LrWpanAckTestCase::DataIndication (LrWpanAckTestCase *testCase, Ptr<LrWpanNetDevice> dev, McpsDataIndicationParams params, Ptr<Packet> p)
+LrWpanAckTestCase::DataIndicationDev0 (McpsDataIndicationParams params, Ptr<Packet> p)
 {
-  if (dev->GetMac ()->GetShortAddress () == Mac16Address ("00:02"))
-    {
-      Ptr<Packet> p = Create<Packet> (10);  // 10 bytes of dummy data
-      McpsDataRequestParams params;
-      params.m_srcAddrMode = SHORT_ADDR;
-      params.m_dstAddrMode = SHORT_ADDR;
-      params.m_dstPanId = 0;
-      params.m_dstAddr = Mac16Address ("00:01");
-      params.m_msduHandle = 0;
-      params.m_txOptions = TX_OPTION_NONE;
-
-      testCase->m_replyTime = Simulator::Now ();
-      dev->GetMac ()->McpsDataRequest (params, p);
-    }
-  else
-    {
-      testCase->m_replyArrivalTime = Simulator::Now ();
-    }
+  m_replyArrivalTime = Simulator::Now ();
 }
 
 void
-LrWpanAckTestCase::DataConfirm (LrWpanAckTestCase *testCase, Ptr<LrWpanNetDevice> dev, McpsDataConfirmParams params)
+LrWpanAckTestCase::DataIndicationDev1 (McpsDataIndicationParams params, Ptr<Packet> p)
 {
-  if (dev->GetMac ()->GetShortAddress () == Mac16Address ("00:01"))
+  Ptr<Packet> pkt = Create<Packet> (10);  // 10 bytes of dummy data
+  McpsDataRequestParams replyParams;
+  replyParams.m_dstPanId = 0;
+  replyParams.m_msduHandle = 0;
+  replyParams.m_txOptions = TX_OPTION_NONE;
+
+  if (m_mode == EXTENDED_ADDRESS_UNICAST)
     {
-      testCase->m_requestAckTime = Simulator::Now ();
-    }
+      replyParams.m_srcAddrMode = EXT_ADDR;
+      replyParams.m_dstAddrMode = EXT_ADDR;
+      replyParams.m_dstExtAddr = Mac64Address ("00:00:00:00:00:00:00:01");
+   }
   else
     {
-      testCase->m_replyAckTime = Simulator::Now ();
+      replyParams.m_srcAddrMode = SHORT_ADDR;
+      replyParams.m_dstAddrMode = SHORT_ADDR;
+      replyParams.m_dstAddr = Mac16Address ("00:01");
     }
+  m_replyTime = Simulator::Now ();
+  m_dev1->GetMac ()->McpsDataRequest (replyParams, pkt);
 }
 
 void
-LrWpanAckTestCase::ExtendedAddressingDataIndication (LrWpanAckTestCase *testCase, Ptr<LrWpanNetDevice> dev, McpsDataIndicationParams params, Ptr<Packet> p)
+LrWpanAckTestCase::DataConfirmDev0 (McpsDataConfirmParams params)
 {
-  if (dev->GetMac ()->GetExtendedAddress () == Mac64Address ("00:00:00:00:00:00:00:02"))
-    {
-      Ptr<Packet> p = Create<Packet> (10);  // 10 bytes of dummy data
-      McpsDataRequestParams params;
-      params.m_srcAddrMode = EXT_ADDR;
-      params.m_dstAddrMode = EXT_ADDR;
-      params.m_dstPanId = 0;
-      params.m_dstExtAddr = Mac64Address ("00:00:00:00:00:00:00:01");
-      params.m_msduHandle = 0;
-      params.m_txOptions = TX_OPTION_NONE;
-
-      testCase->m_replyTime = Simulator::Now ();
-      dev->GetMac ()->McpsDataRequest (params, p);
-    }
-  else
-    {
-      testCase->m_replyArrivalTime = Simulator::Now ();
-    }
+  m_requestSentTime = Simulator::Now ();
 }
 
 void
-LrWpanAckTestCase::ExtendedAddressingDataConfirm (LrWpanAckTestCase *testCase, Ptr<LrWpanNetDevice> dev, McpsDataConfirmParams params)
+LrWpanAckTestCase::DataConfirmDev1 (McpsDataConfirmParams params)
 {
-  if (dev->GetMac ()->GetExtendedAddress () == Mac64Address ("00:00:00:00:00:00:00:01"))
-    {
-      testCase->m_requestAckTime = Simulator::Now ();
-    }
-  else
-    {
-      testCase->m_replyAckTime = Simulator::Now ();
-    }
+  m_replySentTime = Simulator::Now ();
 }
 
 void
@@ -184,7 +177,8 @@
   // immediately answers with a reply packet on reception of the request.
   // We expect the ACK of the request packet to always arrive at node 1 before
   // the reply packet sent by node 2.
-  // The same is repeated for extended addressing mode.
+  // This, of course, unelss the packet is sent to a broadcast or multicast address
+  // in this case we don't expect any ACK.
 
   // Enable calculation of FCS in the trailers. Only necessary when interacting with real devices or wireshark.
   // GlobalValue::Bind ("ChecksumEnabled", BooleanValue (true));
@@ -193,19 +187,27 @@
   RngSeedManager::SetSeed (1);
   RngSeedManager::SetRun (6);
 
+  // Helper - used to create traces
+  LrWpanHelper helper;
+  std::string asciiPrefix;
+
   // Create 2 nodes, and a NetDevice for each one
   Ptr<Node> n0 = CreateObject <Node> ();
   Ptr<Node> n1 = CreateObject <Node> ();
 
-  Ptr<LrWpanNetDevice> dev0 = CreateObject<LrWpanNetDevice> ();
-  Ptr<LrWpanNetDevice> dev1 = CreateObject<LrWpanNetDevice> ();
+  m_dev0 = CreateObject<LrWpanNetDevice> ();
+  m_dev1 = CreateObject<LrWpanNetDevice> ();
 
   // Make random variable stream assignment deterministic
-  dev0->AssignStreams (0);
-  dev1->AssignStreams (10);
+  m_dev0->AssignStreams (0);
+  m_dev1->AssignStreams (10);
 
-  dev0->SetAddress (Mac16Address ("00:01"));
-  dev1->SetAddress (Mac16Address ("00:02"));
+  // Add short addresses.
+  m_dev0->SetAddress (Mac16Address ("00:01"));
+  m_dev1->SetAddress (Mac16Address ("00:02"));
+  // Add extended addresses.
+  m_dev0->GetMac()->SetExtendedAddress (Mac64Address ("00:00:00:00:00:00:00:01"));
+  m_dev1->GetMac()->SetExtendedAddress (Mac64Address ("00:00:00:00:00:00:00:02"));
 
   // Each device must be attached to the same channel
   Ptr<SingleModelSpectrumChannel> channel = CreateObject<SingleModelSpectrumChannel> ();
@@ -214,101 +216,102 @@
   channel->AddPropagationLossModel (propModel);
   channel->SetPropagationDelayModel (delayModel);
 
-  dev0->SetChannel (channel);
-  dev1->SetChannel (channel);
+  m_dev0->SetChannel (channel);
+  m_dev1->SetChannel (channel);
 
   // To complete configuration, a LrWpanNetDevice must be added to a node
-  n0->AddDevice (dev0);
-  n1->AddDevice (dev1);
+  n0->AddDevice (m_dev0);
+  n1->AddDevice (m_dev1);
 
   Ptr<ConstantPositionMobilityModel> sender0Mobility = CreateObject<ConstantPositionMobilityModel> ();
   sender0Mobility->SetPosition (Vector (0,0,0));
-  dev0->GetPhy ()->SetMobility (sender0Mobility);
+  m_dev0->GetPhy ()->SetMobility (sender0Mobility);
   Ptr<ConstantPositionMobilityModel> sender1Mobility = CreateObject<ConstantPositionMobilityModel> ();
   // Configure position 10 m distance
   sender1Mobility->SetPosition (Vector (0,10,0));
-  dev1->GetPhy ()->SetMobility (sender1Mobility);
+  m_dev1->GetPhy ()->SetMobility (sender1Mobility);
 
   McpsDataConfirmCallback cb0;
-  cb0 = MakeBoundCallback (&LrWpanAckTestCase::DataConfirm, this, dev0);
-  dev0->GetMac ()->SetMcpsDataConfirmCallback (cb0);
+  cb0 = MakeCallback (&LrWpanAckTestCase::DataConfirmDev0, this);
+  m_dev0->GetMac ()->SetMcpsDataConfirmCallback (cb0);
 
   McpsDataIndicationCallback cb1;
-  cb1 = MakeBoundCallback (&LrWpanAckTestCase::DataIndication, this, dev0);
-  dev0->GetMac ()->SetMcpsDataIndicationCallback (cb1);
+  cb1 = MakeCallback (&LrWpanAckTestCase::DataIndicationDev0, this);
+  m_dev0->GetMac ()->SetMcpsDataIndicationCallback (cb1);
 
   McpsDataConfirmCallback cb2;
-  cb2 = MakeBoundCallback (&LrWpanAckTestCase::DataConfirm, this, dev1);
-  dev1->GetMac ()->SetMcpsDataConfirmCallback (cb2);
+  cb2 = MakeCallback (&LrWpanAckTestCase::DataConfirmDev1, this);
+  m_dev1->GetMac ()->SetMcpsDataConfirmCallback (cb2);
 
   McpsDataIndicationCallback cb3;
-  cb3 = MakeBoundCallback (&LrWpanAckTestCase::DataIndication, this, dev1);
-  dev1->GetMac ()->SetMcpsDataIndicationCallback (cb3);
+  cb3 = MakeCallback (&LrWpanAckTestCase::DataIndicationDev1, this);
+  m_dev1->GetMac ()->SetMcpsDataIndicationCallback (cb3);
 
   Ptr<Packet> p0 = Create<Packet> (50);  // 50 bytes of dummy data
   McpsDataRequestParams params;
-  params.m_srcAddrMode = SHORT_ADDR;
-  params.m_dstAddrMode = SHORT_ADDR;
+  uint8_t expectedAckCount = 0;
+  switch (m_mode)
+  {
+    case SHORT_ADDRESS_UNICAST:
+      params.m_srcAddrMode = SHORT_ADDR;
+      params.m_dstAddrMode = SHORT_ADDR;
+      params.m_dstAddr = Mac16Address ("00:02");
+      expectedAckCount = 1;
+      break;
+    case SHORT_ADDRESS_MULTICAST:
+      params.m_srcAddrMode = SHORT_ADDR;
+      params.m_dstAddrMode = SHORT_ADDR;
+      params.m_dstAddr = Mac16Address::GetMulticast (Ipv6Address::GetAllNodesMulticast ());
+      expectedAckCount = 0;
+      break;
+    case SHORT_ADDRESS_BROADCAST:
+      params.m_srcAddrMode = SHORT_ADDR;
+      params.m_dstAddrMode = SHORT_ADDR;
+      params.m_dstAddr = Mac16Address::GetBroadcast ();
+      expectedAckCount = 0;
+      break;
+    case EXTENDED_ADDRESS_UNICAST:
+      params.m_srcAddrMode = EXT_ADDR;
+      params.m_dstAddrMode = EXT_ADDR;
+      params.m_dstExtAddr = Mac64Address ("00:00:00:00:00:00:00:02");
+      expectedAckCount = 1;
+      break;
+  }
   params.m_dstPanId = 0;
-  params.m_dstAddr = Mac16Address ("00:02");
   params.m_msduHandle = 0;
   params.m_txOptions = TX_OPTION_ACK;
   m_requestTime = Simulator::Now ();
-  Simulator::ScheduleNow (&LrWpanMac::McpsDataRequest, dev0->GetMac (), params, p0);
-
+  Simulator::ScheduleNow (&LrWpanMac::McpsDataRequest, m_dev0->GetMac (), params, p0);
 
+  helper.EnableAscii (CreateTempDirFilename (m_prefix), m_dev0);
   Simulator::Run ();
 
-  NS_TEST_EXPECT_MSG_LT (m_requestTime, m_replyTime, "Sent the request before the reply (as expected)");
-  NS_TEST_EXPECT_MSG_LT (m_requestAckTime, m_replyArrivalTime, "The request was ACKed before the reply arrived (as expected)");
-  NS_TEST_EXPECT_MSG_LT (m_replyAckTime, m_replyArrivalTime, "The reply was ACKed before the reply arrived (as expected)");
-
-  // Test extended addressing.
-
-  // Resetting the timers.
-  m_requestTime = Seconds (0);
-  m_requestAckTime = Seconds (0);
-  m_replyTime = Seconds (0);
-  m_replyAckTime = Seconds (0);
-  m_replyArrivalTime = Seconds (0);
-
-  // Adding exteneded addresses.
-  dev0->GetMac()->SetExtendedAddress (Mac64Address ("00:00:00:00:00:00:00:01"));
-  dev1->GetMac()->SetExtendedAddress (Mac64Address ("00:00:00:00:00:00:00:02"));
-
-  // Changing callbacks for those with exteneded addressing.
-  cb0 = MakeBoundCallback (&LrWpanAckTestCase::ExtendedAddressingDataConfirm, this, dev0);
-  dev0->GetMac ()->SetMcpsDataConfirmCallback (cb0);
-
-  cb1 = MakeBoundCallback (&LrWpanAckTestCase::ExtendedAddressingDataIndication, this, dev0);
-  dev0->GetMac ()->SetMcpsDataIndicationCallback (cb1);
-
-  cb2 = MakeBoundCallback (&LrWpanAckTestCase::ExtendedAddressingDataConfirm, this, dev1);
-  dev1->GetMac ()->SetMcpsDataConfirmCallback (cb2);
-
-  cb3 = MakeBoundCallback (&LrWpanAckTestCase::ExtendedAddressingDataIndication, this, dev1);
-  dev1->GetMac ()->SetMcpsDataIndicationCallback (cb3);
-
-  Ptr<Packet> p1 = Create<Packet> (50);  // 50 bytes of dummy data
-  params.m_srcAddrMode = EXT_ADDR;
-  params.m_dstAddrMode = EXT_ADDR;
-  params.m_dstPanId = 0;
-  params.m_dstExtAddr = Mac64Address ("00:00:00:00:00:00:00:02");
-  params.m_msduHandle = 0;
-  params.m_txOptions = TX_OPTION_ACK;
-  m_requestTime = Simulator::Now ();
-  Simulator::ScheduleNow (&LrWpanMac::McpsDataRequest, dev0->GetMac (), params, p0);
-
+  std::ifstream traceFile (CreateTempDirFilename (m_prefix)+"-0-0.tr");
+  uint8_t ackCounter = 0;
+  std::string sub ("Frame Type = 2");
+  for( std::string line; getline ( traceFile, line ); )
+    {
+      if (line.find(sub, 0) != std::string::npos)
+        {
+          ackCounter++;
+        }
+    }
+  traceFile.close ();
 
-  Simulator::Run ();
+  // Note: the packet being correctly sent includes receiving an ACK in case of for unicact packets.
+  NS_TEST_EXPECT_MSG_LT (m_requestTime, m_replyTime, "Sent the request before the reply (as expected)");
+  NS_TEST_EXPECT_MSG_GT (m_requestSentTime, Time (0), "The request was sent (as expected)");
+  NS_TEST_EXPECT_MSG_LT (m_requestSentTime, m_replyArrivalTime, "The request was sent before the reply arrived (as expected)");
+  NS_TEST_EXPECT_MSG_LT (m_replySentTime, m_replyArrivalTime, "The reply was sent before the reply arrived (as expected)");
+  NS_TEST_EXPECT_MSG_EQ (ackCounter, expectedAckCount, "The right amount of ACKs have been seen on the channel (as expected)");
 
-  NS_TEST_EXPECT_MSG_LT (m_requestTime, m_replyTime, "ExtendedAddressing: Sent the request before the reply (as expected)");
-  NS_TEST_EXPECT_MSG_LT (m_requestAckTime, m_replyArrivalTime, "ExtendedAddressing: The request was ACKed before the reply arrived (as expected)");
-  NS_TEST_EXPECT_MSG_LT (m_replyAckTime, m_replyArrivalTime, "ExtendedAddressing: The reply was ACKed before the reply arrived (as expected)");
+  m_dev0 = 0;
+  m_dev1 = 0;
 
   Simulator::Destroy ();
 }
 
+
 /**
  * \ingroup lr-wpan-test
  * \ingroup tests
@@ -324,7 +327,10 @@
 LrWpanAckTestSuite::LrWpanAckTestSuite ()
   : TestSuite ("lr-wpan-ack", UNIT)
 {
-  AddTestCase (new LrWpanAckTestCase, TestCase::QUICK);
+  AddTestCase (new LrWpanAckTestCase ("short-unicast", LrWpanAckTestCase::SHORT_ADDRESS_UNICAST), TestCase::QUICK);
+  AddTestCase (new LrWpanAckTestCase ("short-multicast", LrWpanAckTestCase::SHORT_ADDRESS_MULTICAST), TestCase::QUICK);
+  AddTestCase (new LrWpanAckTestCase ("short-broadcast", LrWpanAckTestCase::SHORT_ADDRESS_BROADCAST), TestCase::QUICK);
+  AddTestCase (new LrWpanAckTestCase ("extended-unicast", LrWpanAckTestCase::EXTENDED_ADDRESS_UNICAST), TestCase::QUICK);
 }
 
 static LrWpanAckTestSuite g_lrWpanAckTestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/lte/bindings/modulegen__gcc_ILP32.py ns-3.33/src/lte/bindings/modulegen__gcc_ILP32.py
--- ns-3.32/src/lte/bindings/modulegen__gcc_ILP32.py	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/lte/bindings/modulegen__gcc_ILP32.py	2021-01-09 10:19:22.000000000 -0800
@@ -39,7 +39,7 @@
     ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList [class]
     module.add_class('AttributeConstructionList', import_from_module='ns.core')
     ## attribute-construction-list.h (module 'core'): ns3::AttributeConstructionList::Item [struct]
-    module.add_class('Item', outer_class=root_module['ns3::AttributeConstructionList'], import_from_module='ns.core')
+    module.add_class('Item', import_from_module='ns.core', outer_class=root_module['ns3::AttributeConstructionList'])
     typehandlers.add_type_alias('std::list< ns3::AttributeConstructionList::Item > const_iterator', 'ns3::AttributeConstructionList::CIterator')
     typehandlers.add_type_alias('std::list< ns3::AttributeConstructionList::Item > const_iterator*', 'ns3::AttributeConstructionList::CIterator*')
     typehandlers.add_type_alias('std::list< ns3::AttributeConstructionList::Item > const_iterator&', 'ns3::AttributeConstructionList::CIterator&')
@@ -48,7 +48,7 @@
     ## buffer.h (module 'network'): ns3::Buffer [class]
     module.add_class('Buffer', import_from_module='ns.network')
     ## buffer.h (module 'network'): ns3::Buffer::Iterator [class]
-    module.add_class('Iterator', outer_class=root_module['ns3::Buffer'], import_from_module='ns.network')
+    module.add_class('Iterator', import_from_module='ns.network', outer_class=root_module['ns3::Buffer'])
     ## lte-common.h (module 'lte'): ns3::BufferSizeLevelBsr [class]
     module.add_class('BufferSizeLevelBsr')
     ## ff-mac-common.h (module 'lte'): ns3::BuildBroadcastListElement_s [struct]
@@ -64,13 +64,13 @@
     ## packet.h (module 'network'): ns3::ByteTagIterator [class]
     module.add_class('ByteTagIterator', import_from_module='ns.network')
     ## packet.h (module 'network'): ns3::ByteTagIterator::Item [class]
-    module.add_class('Item', outer_class=root_module['ns3::ByteTagIterator'], import_from_module='ns.network')
+    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::ByteTagIterator'])
     ## byte-tag-list.h (module 'network'): ns3::ByteTagList [class]
     module.add_class('ByteTagList', import_from_module='ns.network')
     ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator [class]
-    module.add_class('Iterator', outer_class=root_module['ns3::ByteTagList'], import_from_module='ns.network')
+    module.add_class('Iterator', import_from_module='ns.network', outer_class=root_module['ns3::ByteTagList'])
     ## byte-tag-list.h (module 'network'): ns3::ByteTagList::Iterator::Item [struct]
-    module.add_class('Item', outer_class=root_module['ns3::ByteTagList::Iterator'], import_from_module='ns.network')
+    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::ByteTagList::Iterator'])
     ## callback.h (module 'core'): ns3::CallbackBase [class]
     module.add_class('CallbackBase', import_from_module='ns.core')
     ## cqa-ff-mac-scheduler.h (module 'lte'): ns3::CqasFlowPerf_t [struct]
@@ -86,19 +86,19 @@
     ## data-rate.h (module 'network'): ns3::DataRate [class]
     module.add_class('DataRate', import_from_module='ns.network')
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeAccessor> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::AttributeAccessor'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::AttributeAccessor'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeChecker> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::AttributeChecker'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::AttributeChecker'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::AttributeValue> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::AttributeValue'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::AttributeValue'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::CallbackImplBase> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::CallbackImplBase'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::CallbackImplBase'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::EpcTft> [struct]
     module.add_class('DefaultDeleter', template_parameters=['ns3::EpcTft'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::EventImpl> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::EventImpl'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::EventImpl'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::Hash::Implementation> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::Hash::Implementation'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::Hash::Implementation'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::LteChunkProcessor> [struct]
     module.add_class('DefaultDeleter', template_parameters=['ns3::LteChunkProcessor'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::LteControlMessage> [struct]
@@ -106,17 +106,17 @@
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::LteHarqPhy> [struct]
     module.add_class('DefaultDeleter', template_parameters=['ns3::LteHarqPhy'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::NixVector> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::NixVector'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::NixVector'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::Packet> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::Packet'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::Packet'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumModel> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::SpectrumModel'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::SpectrumModel'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumSignalParameters> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::SpectrumSignalParameters'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::SpectrumSignalParameters'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::SpectrumValue> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::SpectrumValue'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::SpectrumValue'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::TraceSourceAccessor> [struct]
-    module.add_class('DefaultDeleter', template_parameters=['ns3::TraceSourceAccessor'], import_from_module='ns.core')
+    module.add_class('DefaultDeleter', import_from_module='ns.core', template_parameters=['ns3::TraceSourceAccessor'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::VendorSpecificValue> [struct]
     module.add_class('DefaultDeleter', template_parameters=['ns3::VendorSpecificValue'])
     ## default-deleter.h (module 'core'): ns3::DefaultDeleter<ns3::X2CellInfo> [struct]
@@ -756,19 +756,19 @@
     ## packet-metadata.h (module 'network'): ns3::PacketMetadata [class]
     module.add_class('PacketMetadata', import_from_module='ns.network')
     ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item [struct]
-    module.add_class('Item', outer_class=root_module['ns3::PacketMetadata'], import_from_module='ns.network')
+    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::PacketMetadata'])
     ## packet-metadata.h (module 'network'): ns3::PacketMetadata::Item::ItemType [enumeration]
     module.add_enum('ItemType', ['PAYLOAD', 'HEADER', 'TRAILER'], outer_class=root_module['ns3::PacketMetadata::Item'], import_from_module='ns.network')
     ## packet-metadata.h (module 'network'): ns3::PacketMetadata::ItemIterator [class]
-    module.add_class('ItemIterator', outer_class=root_module['ns3::PacketMetadata'], import_from_module='ns.network')
+    module.add_class('ItemIterator', import_from_module='ns.network', outer_class=root_module['ns3::PacketMetadata'])
     ## packet.h (module 'network'): ns3::PacketTagIterator [class]
     module.add_class('PacketTagIterator', import_from_module='ns.network')
     ## packet.h (module 'network'): ns3::PacketTagIterator::Item [class]
-    module.add_class('Item', outer_class=root_module['ns3::PacketTagIterator'], import_from_module='ns.network')
+    module.add_class('Item', import_from_module='ns.network', outer_class=root_module['ns3::PacketTagIterator'])
     ## packet-tag-list.h (module 'network'): ns3::PacketTagList [class]
     module.add_class('PacketTagList', import_from_module='ns.network')
     ## packet-tag-list.h (module 'network'): ns3::PacketTagList::TagData [struct]
-    module.add_class('TagData', outer_class=root_module['ns3::PacketTagList'], import_from_module='ns.network')
+    module.add_class('TagData', import_from_module='ns.network', outer_class=root_module['ns3::PacketTagList'])
     ## ff-mac-common.h (module 'lte'): ns3::PagingInfoListElement_s [struct]
     module.add_class('PagingInfoListElement_s')
     ## log.h (module 'core'): ns3::ParameterLogger [class]
@@ -804,7 +804,7 @@
     ## ff-mac-common.h (module 'lte'): ns3::SiMessageListElement_s [struct]
     module.add_class('SiMessageListElement_s')
     ## simple-ref-count.h (module 'core'): ns3::SimpleRefCount<ns3::Object, ns3::ObjectBase, ns3::ObjectDeleter> [class]
-    module.add_class('SimpleRefCount', memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'), template_parameters=['ns3::Object', 'ns3::ObjectBase', 'ns3::ObjectDeleter'], import_from_module='ns.core', automatic_type_narrowing=True, parent=root_module['ns3::ObjectBase'])
+    module.add_class('SimpleRefCount', automatic_type_narrowing=True, import_from_module='ns.core', memory_policy=cppclass.ReferenceCountingMethodsPolicy(incref_method='Ref', decref_method='Unref', peekref_method='GetReferenceCount'), parent=root_module['ns3::ObjectBase'], template_parameters=['ns3::Object', 'ns3::ObjectBase', 'ns3::ObjectDeleter'])
     ## simulator.h (module 'core'): ns3::Simulator [class]
     module.add_class('Simulator', destructor_visibility='private', import_from_module='ns.core')
     ## simulator.h (module 'core'): ns3::Simulator [enumeration]
@@ -828,7 +828,7 @@
     ## nstime.h (module 'core'): ns3::Time [class]
     module.add_class('Time', import_from_module='ns.core')
     ## nstime.h (module 'core'): ns3::Time::Unit [enumeration]
-    module.add_enum('Unit', ['Y', 'D', 'H', 'MIN', 'S', 'MS', 'US', 'NS', 'PS', 'FS', 'LAST'], outer_class=root_module['ns3::Time'], import_from_module='ns.core')
+    module.add_enum('Unit', ['Y', 'D', 'H', 'MIN', 'S', 'MS', 'US', 'NS', 'PS', 'FS', 'LAST', 'AUTO'], outer_class=root_module['ns3::Time'], import_from_module='ns.core')
     typehandlers.add_type_alias('void ( * ) ( ns3::Time )', 'ns3::Time::TracedCallback')
     typehandlers.add_type_alias('void ( * ) ( ns3::Time )*', 'ns3::Time::TracedCallback*')
     typehandlers.add_type_alias('void ( * ) ( ns3::Time )&', 'ns3::Time::TracedCallback&')
@@ -843,9 +843,9 @@
     ## type-id.h (module 'core'): ns3::TypeId::SupportLevel [enumeration]
     module.add_enum('SupportLevel', ['SUPPORTED', 'DEPRECATED', 'OBSOLETE'], outer_class=root_module['ns3::TypeId'], import_from_module='ns.core')
     ## type-id.h (module 'core'): ns3::TypeId::AttributeInformation [struct]
-    module.add_class('AttributeInformation', outer_class=root_module['ns3::TypeId'], import_from_module='ns.core')
+    module.add_class('AttributeInformation', import_from_module='ns.core', outer_class=root_module['ns3::TypeId'])
     ## type-id.h (module 'core'): ns3::TypeId::TraceSourceInformation [struct]
-    module.add_class('TraceSourceInformation', outer_class=root_module['ns3::TypeId'], import_from_module='ns.core')
+    module.add_class('TraceSourceInformation', import_from_module='ns.core', outer_class=root_module['ns3::TypeId'])
     typehandlers.add_type_alias('uint32_t', 'ns3::TypeId::hash_t')
     typehandlers.add_type_alias('uint32_t*', 'ns3::TypeId::hash_t*')
     typehandlers.add_type_alias('uint32_t&', 'ns3::TypeId::hash_t&')
@@ -998,7 +998,7 @@
     ## object.h (module 'core'): ns3::Object [class]
     module.add_class('Object', import_from_module='ns.core', parent=root_module['ns3::SimpleRefCount< ns3::Object, ns3::ObjectBase, ns3::ObjectDeleter >'])
     ## object.h (module 'core'): ns3::Object::AggregateIterator [class]
-    module.add_class('AggregateIterator', outer_class=root_module['ns3::Object'], import_from_module='ns.core')
+    module.add_class('AggregateIterator', import_from_module='ns.core', outer_class=root_module['ns3::Object'])
     ## packet-burst.h (module 'network'): ns3::PacketBurst [class]
     module.add_class('PacketBurst', import_from_module='ns.network', parent=root_module['ns3::Object'])
     typehandlers.add_type_alias('void ( * ) ( ns3::Ptr< ns3::PacketBurst const > )', 'ns3::PacketBurst::TracedCallback')
